#################################################### 
#       Solutions to Worksheet from Chap. 12        #
#                     Simulations                   #
#####################################################

# E- Box-Muller theorem

# 12.1-
n <- 1000
u1 <- runif(n)
u2 <- runif(n)
z1 <- sqrt(-2*log(u1))*cos(2*pi*u2)
z2 <- sqrt(-2*log(u1))*sin(2*pi*u2)
# 12.2- Non parametric estimation of the density:
require("MASS")
ngrid <- 40
denobj<-kde2d(z1,z2,n=ngrid)
den.z <-denobj$z
# 12.3- Surface of the density of the bivariate normal:
require("rgl")
xgrid <- denobj$x
ygrid <- denobj$y
bi.z <- dnorm(xgrid)%*%t(dnorm(ygrid))
#      New window:
open3d()
bg3d(color="#887777")
light3d()
#      Representing simulated data:
spheres3d(z1,z2,rep(0,n),radius=0.1,color="#CCCCFF")
#      Representing the non parametric estimated density:
surface3d(xgrid,ygrid,den.z*20,color="#FF2222",alpha=0.5)
#      Representing the standard bivariate normale:
surface3d(xgrid,ygrid,bi.z*20,color="#CCCCFF",
          front="lines")
